package at.herold.test.objlifetime;
/**
 * A Timer to avoid calling <code>System.currentTimeMillis()</code> too frequently.
 * @author Peter Kofler
 */
final class TimerThread extends Thread
{

   private static final int TIMER_SLEEP_TIME = 100;
   static int time = 0;

   public final void run()
   {
      while (true)
      {
         try
         {
            Thread.sleep(TimerThread.TIMER_SLEEP_TIME);
            time++;
         }
         catch (InterruptedException e)
         {
            System.out.println("LTM error in Timer Thread");
            e.printStackTrace();
            return;
         }
      }
   }

   public static void createAndStart()
   {
      final Thread timer = new TimerThread();
      timer.setPriority(Thread.MAX_PRIORITY);
      timer.setDaemon(true);
      timer.start();
      System.out.println("LTM started Timer Thread");
   }

}
