package at.herold.test.objlifetime.viewer;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
/**
 * List containing all creation events loaded from the log file using a list.
 * @author Peter Kofler
 */
public class CreationEventListWithList implements CreationEventList
{

   private final List creationEvents = new ArrayList();

   public ViewedCreationEvent getDoubledEventFor(ViewedCreationEvent ev)
   {
      int i = creationEvents.indexOf(ev);
      if (i != -1)
      {
         return (ViewedCreationEvent) creationEvents.get(i);
      }

      return null;
   }

   public ViewedCreationEvent getCreationEventFor(ViewedGCEvent ev) {
      int i = creationEvents.indexOf(ev);
      if (i != -1)
      {
         return (ViewedCreationEvent) creationEvents.get(i);
      }

      return null;
   }

   public void addEvent(ViewedCreationEvent ev)
   {
      creationEvents.add(ev);
   }

   public void remove(ViewedCreationEvent ev)
   {
      int i = creationEvents.indexOf(ev);
      if (i == -1)
      {
         throw new IllegalArgumentException("elemnt " + ev + " not in list");
      }

      creationEvents.remove(i);
   }

   public void clear()
   {
      creationEvents.clear();
   }

   public Iterator iterator()
   {
      return creationEvents.iterator();
   }

   public int size()
   {
      return creationEvents.size();
   }

}
