package at.herold.test.objlifetime.viewer;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
/**
 * List containing all creation events loaded from the log file using a map.
 * @author Peter Kofler
 */
public class CreationEventListWithMap implements CreationEventList
{

   private final Map creationEvents = new HashMap();

   public ViewedCreationEvent getDoubledEventFor(ViewedCreationEvent ev)
   {
      return (ViewedCreationEvent) creationEvents.get(ev);
   }

   public ViewedCreationEvent getCreationEventFor(ViewedGCEvent ev) {
      return (ViewedCreationEvent) creationEvents.get(ev);
   }
   
   public void addEvent(ViewedCreationEvent ev)
   {
      creationEvents.put(ev, ev);
   }

   public void remove(ViewedCreationEvent ev)
   {
      int size = creationEvents.size();
      creationEvents.remove(ev);
      if (creationEvents.size()+1!=size) throw new RuntimeException("removed not exactly one");
   }

   public void clear()
   {
      creationEvents.clear();
   }

   public Iterator iterator()
   {
      return creationEvents.values().iterator();
   }

   public int size()
   {
      return creationEvents.size();
   }
   
}
