package at.herold.test.objlifetime.viewer;

import java.awt.Graphics;
/**
 * Class to analyse the lifetime. Results are printed and drawn. The default
 * implementation assumes that no graphic is created. 
 * @author Peter Kofler
 */
public abstract class LifeTimeAnalyser
{
   protected ViewedLifetimeStatistics data;

   public abstract void analyse(ViewedLifetimeStatistics pData);

   public abstract void printResults();

   public int getPaintYAxis()
   {
      return 0;
   }

   public int getPaintXAxis()
   {
      return 0;
   }

   public void paintResults(Graphics g)
   {
      if (g!=null) throw new IllegalStateException("operation not supported");
   }

}