package at.herold.test.objlifetime.viewer;

import java.util.List;

class ViewedCreationEvent extends ViewedEvent
{

   final String className;

   ViewedCreationEvent(int pObjectIdentifier, int pTimeStamp, String pClassName)
   {
      super(pObjectIdentifier, pTimeStamp);
      this.className = pClassName.intern();
   }

   public String toString()
   {
      return "C @" + super.toString() + " " + className;
   }

   /**
    * Equals hack - creation events are just equal if they have the same identifier and time.
    * But GC event is equal to creation event if they have the same identifier.
    */
   public boolean equals(Object obj)
   {
      if (obj instanceof ViewedCreationEvent)
      {
         // always different!
         return false;
         // ViewedCreationEvent vce = (ViewedCreationEvent) obj;
         // return vce.objectIdentifier == objectIdentifier && vce.timeStamp == timeStamp && vce.className.equals(className);
      }

      return super.equals(obj);
   }

   public void operateList(CreationEventList creationEvents, List lifetimeEvents)
   {
      /*
      // get a possibly double creation for me - will not be as the creation events are just equal if same time
      final ViewedCreationEvent first = creationEvents.getDoubledEventFor(this);
      if (first!=null) {
         // time too short to measure!
         creationEvents.remove(first);
      
         final ViewedLifetime lifetime = new ViewedLifetime(first);
         lifetime.setEndTime(this.timeStamp); 
         lifetimeEvents.add(lifetime);     
      }
      */
      creationEvents.addEvent(this);
   }

}
