package at.herold.test.objlifetime.viewer;
/**
 * Computed value of the lifetime of a single object.
 * @author Peter Kofler
 */
public class ViewedLifetime
{

   final int objectIdentifier;
   final int startTimeStamp;
   final String className;

   int endTimeStamp;
   int lifetime;
   boolean endedByShutdown;

   public ViewedLifetime(ViewedCreationEvent ev)
   {
      objectIdentifier = ev.objectIdentifier;
      startTimeStamp = ev.timeStamp;
      className = ev.className;
      // ev.classname has been interned already
   }

   public void setEndTime(ViewedGCEvent ev) {
      if (ev.objectIdentifier!=objectIdentifier) {
         throw new IllegalArgumentException("not the same object"); 
      }
      setEndTime(ev.timeStamp);
   }

   public void setEndTime(int pEndTime) {
      if (endTimeStamp!=0) {
         throw new IllegalArgumentException("already end time set"); 
      }

      endTimeStamp = pEndTime;
      lifetime = endTimeStamp- startTimeStamp;
      endedByShutdown = false;
   }

   public void setEndTimeByShutdown(int time) {
      if (endTimeStamp!=0) {
         throw new IllegalArgumentException("already end time set"); 
      }
      endTimeStamp = time;
      lifetime = endTimeStamp- startTimeStamp;
      endedByShutdown = true;
   }
   
}
